=begin
Customers:
  customerID,
  name
Order:
  orderId
  customerID
  date
LineItem:
  lineNumber
  orderId
  cost
  product
=end

class MockDbh
  def select_one(sql, key)
    r = executesql(sql, key)
    if Array === r
      return r[0]
    else
      return r
    end
  end

  def select_all(sql, key, &blk)
    r = executesql(sql, key)
    if (blk.nil?)
      return r
    else
      r.each(&blk)
    end
  end

  def execute(sql, key, &blk)
    r = executesql(sql, key)
    if (blk.nil?)
      return r
    else
      yield r
    end
  end

  def executesql(sql, val)
    result = []
    key = '?'
    if !(sql.index('orders').nil?)
      key = 'customerID'
      data = [
	{'orderID'=>1, 'customerID'=>'0101', 'date'=>Time.local(2003,10,1)},
	{'orderID'=>2, 'customerID'=>'0102', 'date'=>Time.local(2003,10,3)},
	{'orderID'=>3, 'customerID'=>'0101', 'date'=>Time.local(2003,10,5)},
	{'orderID'=>4, 'customerID'=>'0102', 'date'=>Time.local(2003,10,15)},
	{'orderID'=>5, 'customerID'=>'0101', 'date'=>Time.local(2003,11,1)},
	{'orderID'=>6, 'customerID'=>'0101', 'date'=>Time.local(2003,11,5)},
	{'orderID'=>7, 'customerID'=>'0101', 'date'=>Time.local(2003,12,1)},
	{'orderID'=>8, 'customerID'=>'0101', 'date'=>Time.local(2003,12,5)},
	{'orderID'=>9, 'customerID'=>'0101', 'date'=>Time.local(2003,12,1)},
	{'orderID'=>10, 'customerID'=>'0101', 'date'=>Time.local(2004,1,1)},
      ]
    elsif !(sql.index('lineItems').nil?)
      key = 'orderID'
      data = [
	{ 'lineNumber'=>10, 'orderID'=>2, 'cost'=>2000, 'product'=>'Talisker' },
	{ 'lineNumber'=>11, 'orderID'=>2, 'cost'=>2000, 'product'=>'Talisker' },
	{ 'lineNumber'=>12, 'orderID'=>2, 'cost'=>2000, 'product'=>'Talisker' },
	{ 'lineNumber'=>13, 'orderID'=>4, 'cost'=>10000, 'product'=>'Balisker' },
	{ 'lineNumber'=>14, 'orderID'=>5, 'cost'=>2000, 'product'=>'Talisker' },
	{ 'lineNumber'=>15, 'orderID'=>5, 'cost'=>2000, 'product'=>'Talisker' },
	{ 'lineNumber'=>16, 'orderID'=>5, 'cost'=>2000, 'product'=>'Talisker' },
	{ 'lineNumber'=>17, 'orderID'=>6, 'cost'=>10000, 'product'=>'Balisker' },
	{ 'lineNumber'=>18, 'orderID'=>7, 'cost'=>10000, 'product'=>'Balisker' },
	{ 'lineNumber'=>19, 'orderID'=>8, 'cost'=>10000, 'product'=>'Talisker' },
      ]
    elsif !(sql.index('customers').nil?)
      key = 'name'
      data = [
	{ 'customerID'=>'0101', 'name'=>'John' },
	{ 'customerID'=>'0102', 'name'=>'Mary' },
      ]
    end
    data.each do |r|
      if r[key] == val
	result << r
      end
    end
    result
  end
end

$dbh = MockDbh.new
